# aesophia

This is the **sophia** compiler for the æternity system which compiles contracts written in **sophia** to [FATE](https://github.com/aeternity/protocol/blob/master/contracts/fate.md) instructions.

The compiler is currently being used three places

* [The command line compiler](https://github.com/aeternity/aesophia_cli)
* [The HTTP compiler](https://github.com/aeternity/aesophia_http)
* In [æternity node](https://github.com/aeternity/aeternity) tests

## Documentation

* [Introduction](/developer-documentation/aesophia/docs/index.md)
* [Syntax](/developer-documentation/aesophia/docs/sophia_syntax.md)
* [Features](/developer-documentation/aesophia/docs/sophia_features.md)
* [Standard library](/developer-documentation/aesophia/docs/sophia_stdlib.md)
* [Contract examples](/developer-documentation/aesophia/docs/sophia_examples.md)
* [Contributing](/developer-documentation/aesophia/contributing.md)

Additionally you can check out the [contracts section](https://github.com/aeternity/protocol/blob/master/contracts/contracts.md) of the æternity blockchain specification.

## Versioning

Versioning should follow the [semantic versioning](https://semver.org/spec/v2.0.0) guidelines. Id est, given a version number MAJOR.MINOR.PATCH, increment the:

* MAJOR version when you make incompatible API changes
* MINOR version when you add functionality in a backwards compatible manner
* PATCH version when you make backwards compatible bug fixes

## Interface Modules

The basic modules for interfacing the compiler:

* [aeso\_compiler: the Sophia compiler](/developer-documentation/aesophia/docs/aeso_compiler.md)
* [aeso\_aci: the ACI interface](/developer-documentation/aesophia/docs/aeso_aci.md)


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.aeternity.com/developer-documentation/aesophia.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
